clear;
clc;
close all;
addpath(genpath('.'));

%% Expert Setting

%Environment
T = 3000;


pred = zeros(T,1);
loss = zeros(T,1);
y_t = [];

experts = {@constant_exp, @greedy_exp, @window_exp};
n_exp = length(experts);
exp_loss = zeros(n_exp, T);

% EWA
hat_w = ones(n_exp, 1);
eta = 0.5;

for tt = 1:T
    % Experts Advice
    for ii = 1:3
        exp_advice(ii, 1) = experts{ii}(y_t);
    end
    
    % Algortithm choice   
    % pred(tt) =

    %Reward
    [y, loss(tt), exp_loss(:, tt)] = random_walk_env(pred(tt), exp_advice, @quad_loss);
    
    %Update statistics
    % hat_w 
    y_t = [y_t y];
end


%% Plot Losses
alg_loss = cumsum(loss);
exp_losses = cumsum(exp_loss');

figure();
plot([alg_loss exp_losses]);

%% Plot Regret
regret = cumsum(loss) - min(cumsum(exp_loss'), [], 2);
plot_regret(regret');
hold on

% Plot bounds
%% Write the expression of the bound